import { IBuildable, ICleanable, IDirty, IErrors, IGuid, IResetable, IStates, IValues, ObjectProperties, ObjectValues } from './types';
export declare class ObjectState<TObject> implements IDirty, ICleanable, IResetable, IBuildable<TObject>, IValues<TObject>, IErrors, IStates, IGuid {
    properties: ObjectProperties<TObject>;
    get guid(): string;
    get isDirty(): boolean;
    get errors(): string[];
    set errors(errors: string[]);
    get hasErrors(): boolean;
    get values(): ObjectValues<TObject>;
    get isNew(): boolean;
    get isDeleted(): boolean;
    constructor(obj: TObject);
    build(): TObject;
    clean(): void;
    reset(): void;
    clearErrors(): void;
    markAsDeleted(): this;
    markAsNew(): this;
}
