import StateValues from './state-values';
import { IBuildable, ICleanable, IDirty, IErrors, IGuid, IResetable, IStates, IValues, ObjectProperties, ObjectValues } from './types';
export declare class PropertiesState<TObject> implements IDirty, IBuildable<TObject>, IValues<TObject>, ICleanable, IResetable, IErrors, IStates, IGuid {
    private _guid;
    private _properties;
    private _original;
    private _key;
    private _values;
    private _errors;
    private _isNew;
    private _isDeleted;
    get guid(): string;
    get isDirty(): boolean;
    get key(): string;
    get values(): ObjectValues<TObject> & StateValues<TObject>;
    get errors(): string[];
    set errors(errors: string[]);
    get hasErrors(): boolean;
    get isNew(): boolean;
    get isDeleted(): boolean;
    constructor(key: string, obj: TObject, properties: ObjectProperties<TObject>);
    build(): TObject;
    clean(): void;
    reset(): void;
    clearErrors(): void;
    markAsDeleted(): this;
    markAsNew(): this;
}
