import { IBuildable, ICleanable, IDirty, IErrors, IResetable } from './types';
export declare class PropertyState<TValue> implements IDirty, IBuildable<TValue>, ICleanable, IResetable, IErrors {
    private _key;
    private _value;
    private _original;
    private _errors;
    get key(): string;
    get value(): TValue;
    set value(value: TValue);
    get errors(): string[];
    set errors(errors: string[]);
    get hasErrors(): boolean;
    get isDirty(): boolean;
    constructor(key: string, value: TValue);
    reset(value?: TValue): void;
    build(): TValue;
    clean(): void;
    clearErrors(): void;
    private getResetValue;
}
